Botan 2.19.5 Crypto and TLS for C&

Public Member Functions | Protected Member Functions | List of all members
Botan::Base64_Decoder Class Referencefinal

`#include <filters.h>`

Inheritance diagram for Botan::Base64_Decoder:

## Public Member Functions
virtual bool | attachable ()
| Base64_Decoder (Decoder_Checking checking=NONE)
void | end_msg () override
std::string | name () const override
virtual void | start_msg ()
void | write (const uint8_t input[], size_t length) override

## Protected Member Functions
template<typename Alloc >
void | send (const std::vector< uint8_t, Alloc > &in)
template<typename Alloc >
void | send (const std::vector< uint8_t, Alloc > &in, size_t length)
virtual void | send (const uint8_t in[], size_t length)
void | send (uint8_t in)

## Detailed Description

This object represents a Base64 decoder.

Definition at line 544 of file filters.h.

## Constructor & Destructor Documentation

## ◆ Base64_Decoder()

Botan::Base64_Decoder::Base64_Decoder | ( | Decoder_Checking | checking = `NONE` | ) |
| explicit

Create a base64 decoder.

Parameters

  checking | the type of checking that shall be performed by the decoder

Definition at line 115 of file b64_filt.cpp.

115 :
116 m_checking(c), m_in(64), m_out(48), m_position(0)
117 {
118 }

## Member Function Documentation

## ◆ attachable()

virtual bool Botan::Filter::attachable | ( |  | ) |
| inline virtual inherited

Check whether this filter is an attachable filter.

Returns
  true if this filter is attachable, false otherwise

Reimplemented in Botan::DataSink, and Botan::SecureQueue.

Definition at line 52 of file filter.h.

52{ return true; }

## ◆ end_msg()

void Botan::Base64_Decoder::end_msg | ( |  | ) |
| override virtual

Finish up the current message

Reimplemented from Botan::Filter.

Definition at line 162 of file b64_filt.cpp.

163 {
164 size_t consumed = 0;
165 size_t written = base64_decode(m_out.data(),
166 cast_uint8_ptr_to_char(m_in.data()),
167 m_position,
168 consumed,
169 true,
170 m_checking != FULL_CHECK);
171
172 send(m_out, written);
173
174 const bool not_full_bytes = consumed != m_position;
175
176 m_position = 0;
177
178 if(not_full_bytes)
179 throw Invalid_Argument("Base64_Decoder: Input not full bytes");
180 }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27
Botan::base64_decode
size_t base64_decode(uint8_t out[], const char in[], size_t input_length, size_t &input_consumed, bool final_inputs, bool ignore_ws)
Definition: base64.cpp:200
Botan::cast_uint8_ptr_to_char
const char * cast_uint8_ptr_to_char(const uint8_t *b)
Definition: mem_ops.h:195
Botan::FULL_CHECK
@ FULL_CHECK
Definition: filter.h:171

References Botan::base64_decode(), Botan::cast_uint8_ptr_to_char(), Botan::FULL_CHECK, and Botan::Filter::send().

## ◆ name()

std::string Botan::Base64_Decoder::name | ( |  | ) | const
| inline override virtual

Returns
  descriptive name for this filter

Implements Botan::Filter.

Definition at line 547 of file filters.h.

547{ return "Base64_Decoder"; }

## ◆ send() [1/4]

template<typename Alloc >

void Botan::Filter::send | ( | const std::vector< uint8_t, Alloc > & | in | ) |
| inline protected inherited

Parameters

  in | some input for the filter

Definition at line 71 of file filter.h.

72 {
73 send(in.data(), in.size());
74 }

## ◆ send() [2/4]

template<typename Alloc >

void Botan::Filter::send | ( | const std::vector< uint8_t, Alloc > & | in,
|  | size_t | length
| ) |  |
| inline protected inherited

Parameters

  in | some input for the filter
  length | the number of bytes of in to send

Definition at line 81 of file filter.h.

82 {
83 BOTAN_ASSERT_NOMSG(length <= in.size());
84 send(in.data(), length);
85 }
BOTAN_ASSERT_NOMSG
#define BOTAN_ASSERT_NOMSG(expr)
Definition: assert.h:68

References BOTAN_ASSERT_NOMSG.

## ◆ send() [3/4]

void Botan::Filter::send | ( | const uint8_t | in[],
|  | size_t | length
| ) |  |
| protected virtual inherited

Parameters

  in | some input for the filter
  length | the length of in

Definition at line 27 of file filter.cpp.

28 {
29 if(!length)
30 return;
31
32 bool nothing_attached = true;
33 for(size_t j = 0; j != total_ports(); ++j)
34 if(m_next[j])
35 {
36 if(m_write_queue.size())
37 m_next[j]->write(m_write_queue.data(), m_write_queue.size());
38 m_next[j]->write(input, length);
39 nothing_attached = false;
40 }
41
42 if(nothing_attached)
43 m_write_queue += std::make_pair(input, length);
44 else
45 m_write_queue.clear();
46 }
Botan::Filter::write
virtual void write(const uint8_t input[], size_t length)=0

References Botan::Filter::write().

Referenced by Botan::Base64_Encoder::end_msg(), end_msg(), Botan::Hex_Encoder::end_msg(), Botan::Hex_Decoder::end_msg(), write(), and Botan::Hex_Decoder::write().

## ◆ send() [4/4]

void Botan::Filter::send | ( | uint8_t | in | ) |
| inline protected inherited

Parameters

  in | some input for the filter

Definition at line 65 of file filter.h.

65{ send(&in, 1); }

References Botan::Filter::send().

Referenced by Botan::Filter::send().

## ◆ start_msg()

virtual void Botan::Filter::start_msg | ( |  | ) |
| inline virtual inherited

Start a new message. Must be closed by end_msg() before another message can be started.

Definition at line 40 of file filter.h.

40{ /* default empty */ }

## ◆ write()

void Botan::Base64_Decoder::write | ( | const uint8_t | input[],
|  | size_t | length
| ) |  |
| override virtual

Input a part of a message to the decoder.

Parameters

  input | the message to input as a byte array
  length | the length of the byte array input

Implements Botan::Filter.

Definition at line 123 of file b64_filt.cpp.

124 {
125 while(length)
126 {
127 size_t to_copy = std::min<size_t>(length, m_in.size() - m_position);
128 if(to_copy == 0)
129 {
130 m_in.resize(m_in.size()*2);
131 m_out.resize(m_out.size()*2);
132 }
133 copy_mem(&m_in[m_position], input, to_copy);
134 m_position += to_copy;
135
136 size_t consumed = 0;
137 size_t written = base64_decode(m_out.data(),
138 cast_uint8_ptr_to_char(m_in.data()),
139 m_position,
140 consumed,
141 false,
142 m_checking != FULL_CHECK);
143
144 send(m_out, written);
145
146 if(consumed != m_position)
147 {
148 copy_mem(m_in.data(), m_in.data() + consumed, m_position - consumed);
149 m_position = m_position - consumed;
150 }
151 else
152 m_position = 0;
153
154 length -= to_copy;
155 input += to_copy;
156 }
157 }
Botan::copy_mem
void copy_mem(T *out, const T *in, size_t n)
Definition: mem_ops.h:133

References Botan::base64_decode(), Botan::cast_uint8_ptr_to_char(), Botan::copy_mem(), Botan::FULL_CHECK, and Botan::Filter::send().

The documentation for this class was generated from the following files:

- src/lib/filters/filters.h
- src/lib/filters/b64_filt.cpp